/*  			wp						*/
/* Usage:  wp k > file   						*/
/* where k=0 - exact model, k=1 - White model (NH),                     */
/* k=2 -- Miller-Pearce model (NH), k=3 -- HS model     		*/
/* file on andmefail gnuplotile						*/
/*									*/
/* Computation of vertical velocity in pressure space throuhg  a(x,z)	*/
/*									*/
/* Orography is defined within the program source code			*/
/* Flow parameters defined within the program source code		*/
/************************************************************************/

#include <math.h>
#define NLEV 100
#define NX 512  /* Only powers of 2 are allowed */

float FR[NLEV+1][2*(NX+1)];
float h[2*(2*NX+1)],htul[2*NX+1],habi[2*(2*NX+1)],rphi[NX+4],iphi[NX+4],krt[NX+4];
float Hnull,Nruut,Uruut,delta,alpha,H1;

main(argc,argv)
int argc;
char *argv[];
{
	int it, itmax=2,iip,iim;
	int m,mpool,n,i,ii,iii,isign;
	int j,jm,icr,mi, variant;
	int len[2];
	float NORM,h0,x,x0,l,L,dx,dx2,s,ds;
	float U0,caruut,R,T0,Hnullruut,ciruut,fruut;
	float k,my,csfi,snfi,a,a1,b,eimfi,rh,ih, hinit;
	float ffr,ffi,q1,q2,q3,q4,q5,kruut,q,f0;
	float a0,htuli,dsHnull;
	float rphii,iphii,phiruut,knruut,alfr,rteg,iteg,res,ims;
	float udx2,fp,fm;
	float ab, gg, p0, sprs[(2*NX+1)];
/***********************************************************************/
/* This area is for definition of the flow characteristics             */
/* for Sestroretsk summerschool 2006                                   */
        T0 = 280.;   /* Temperature for constant profile (K) */
	U0 = 25.0;   /* Horisontal flow velocity (m/s) */
	h0 = 250.;   /* Mountain height (m) */
        a0 = 3.e4;   /* Mountain half-width (m) */
	dx = 2.5e3;  /* Horisontal resolution (m) */

/* Definition of orography profile					*/
/* h(x)=h0/(1+(x-x0)**2/l**2)  			   			*/ 
        l=a0/dx;
        x0=(float)NX/2.;
	for(i=0, ii=1; i < NX; i++)
          {
            x=(float)i;
            a=(x-x0)/l;
           h[ii++]=h0/(1.+a*a);
//            ab=M_PI*(x-x0)/(4000.0/dx);    /* Schaer profile*/
//            h[ii++]=h0*exp(-a*a)*cos(ab)*cos(ab); /* Schaer profile*/
            ii++;
          }
/***********************************************************************/
	variant = atoi(argv[1]);

	m=NX;  /* lubatud vaid kahe astmed! m<= 1024*/

	n=NLEV;  /* tasemete arv atmosfaeris. 50 olgu maximaalne, tasemele  */
	      /* 0 vastaku kosmos*/
	mpool=m/2;
/* Atmosf. ja orograafia parameetrid					*/
	ds=1./(float)n;
        gg = 9.81;
        alpha=720./1007.;		/* c_v/c_p	*/
	R=287.;
        caruut=R*T0/alpha;	/* haalekiiruse ruut	*/
        Hnull=R*T0/gg;		/* hom. atmosf. korgusskaala	*/
        Nruut=gg*gg/1007./T0;	/* Vaisala parameetri ruut	*/
//        Nruut=1.0e-4;	/* Vaisala parameetri ruut	*/
        fruut=1.e-8;		/* Coriolis param ruut	*/
        L=NX*dx;
/***********************************************************************/
        H1=gg/Nruut;		/* pot temp. korgusskaala	*/
        Hnullruut=Hnull*Hnull;		/* 	*/
        ciruut=Nruut*Hnullruut;	/* ujulainete f.kiiruse ruut	*/
        Uruut=U0*U0;		/* foonikiiruse ruut	*/
        delta=Hnull/H1; 		/* =T_i/T_0			*/
        knruut=Nruut/Uruut;	/* Kr. lainearvu ruut		*/
        alfr=(alpha-0.5)*(alpha-0.5);
	NORM = (float)m;
	len[1] = m; 
	dx2=dx*2.;
        p0 = 100000.0;
        
        ii=1;
        for(i=0;i < m;i++)
          {
            sprs[i] = p0/exp(h[ii]/Hnull);
            ii = ii +2;
          }
	for (i=1,iim=1,iip=5;i<m-1;i++){
	 	htul[i]=(h[iip++]-h[iim++])/dx2;
		iip++;
		iim++;
	}

/* juurte mu_j arvutus	G172 (4.7)  alusel (seal q(k)) 
   ja kriitilise indeksi leidmine 				*/
        
        q1=1.-Uruut/caruut; q2=fruut/caruut;
        q3=ciruut/Uruut;    q4=(alpha-.5); q4=q4*q4;
		q5=fruut/Uruut;	/*		*/
/*	rphi[0]=iphi[0]=0.;	 nullitakse,et ei oleks maeramatud	*/
	for(i=1;i <= mpool+1;i++) {
		k = 2./dx*sin(M_PI*i/(float)m);
		kruut=k*k;
		krt[i]=kruut;
		if(variant == 0)
		q=(q1+q2/kruut)*(q3-Hnullruut*kruut)/(1.-q5/kruut)-q4; 
			/*Kui kasutame seda
                    varianti, siis peab i>=1 olema, muidu tuleb nulliga
                    jagamine. Nullindaid elemente ei l"ahe ka vaja, kui
                    kasutame ampl. a asymptootilist nullimist   	*/
/*		q=q1*(q3-Hnullruut*kruut)-q4; /* vastab mudelile f=0.	*/
		else if (variant == 1)
		q=(1.+q2/kruut)*(q3-Hnullruut*kruut)/(1.-q5/kruut)-q4; 
		else if (variant == 2)
		q=(q3-Hnullruut*kruut)/(1.-q5/kruut)-0.25;
		else if (variant == 3)
		q=q3/(1.-q5/kruut)-0.25;
		else exit(1);

		my=sqrt(fabs(q));
		if(q >= 0.){
			rphi[i]=my;iphi[i]=0.;
		}	
		else{
			rphi[i]=0.;iphi[i]=-my;
		}	
	}

/* Potentsiaali a  Four. koeffitsientide arvutus  G172 , IVpt valemite 	*/
/* (6b) ja (6c) alusel						 	*/
/*Sellele j"argnev chi (voolufunktsioon.) koeffitsientide leidmine jas3/aarneyl
  (14') abil alusel sama tsykli sees					*/

	dsHnull=ds*Hnull;
	for(it=1;it<=itmax;it++){
		 for(i=1;i <= 2*m ;i++) {
			habi[i]=h[i];	
		 }

  		tavalip(habi,FR,m,n,rphi,iphi,krt,1,variant); 
	       	 	 /* aarne vahemoodul. leiab amplituudi a=FR[j][i] 
			kui tun!=0 jaT'/T=FR[j][i], kui tun==0 
			arvutus toimub p--koordinaadis
			*/ 

		if(it < itmax){ /* parandab it.slt eff. orograafiat */
			for(i = 1,iim=1,iip=5, ii=1;i < m-1;i++){
                      htuli=htul[i]*(1.+(FR[0][i]-(1.-ds)*FR[1][i])/dsHnull);
		      h[iip++]=h[iim++]+htuli*dx2;
			iip++;
			iim++;
			}
		}
	}
/***  Verikaalkiiruse arvutus a--st koos v"aljastamisega 	***/


	udx2=U0/dx2;
	for(j=0;j <= n;j++) {
		for(i=0;i < m;i++) {
			if(i==0){
				fp=FR[j][i+1];
				fm=FR[j][i];
			}
			else if(i==m-1){
				fp=FR[j][i];
				fm=FR[j][i-1];
			}
			else {
				fp=FR[j][i+1];
				fm=FR[j][i-1];
			}
			ffr=(fp-fm)*udx2;
//			printf("%g %g %g\n", (i-x0)*dx, (1.-j*ds)*1000., ffr);
			printf("%g %g %g\n", (i-x0)*dx, (1.-j*ds)*sprs[i], ffr);
		}
		printf("\n");
	}
}
